//+------------------------------------------------------------------+
//|                                                  CARRY_TRADE.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string symb1 = "EURUSD";
extern string symb2 = "USDCHF";
extern int timestart= 19;
extern int timefin  = 9;
extern int magic = 97878;
extern int profit = 2;
int ticket1,ticket2,ticket,prof;
string symb;
static int tick1=0,tick2=0,prevtime = 0 ;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
int total = OrdersTotal();
  for(int i = 0;i<total;i++)
   {
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
     if(OrderSymbol()==symb1&&OrderMagicNumber()==magic){ticket1=OrderTicket();} 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);   
       if(OrderSymbol()==symb2&&OrderMagicNumber()==magic){ticket2=OrderTicket();}
        }
  double svop1 = MarketInfo(symb1,MODE_SWAPSHORT);    
  double svop2 = MarketInfo(symb2,MODE_SWAPSHORT); 
  Print(svop1,"  ",svop2);     
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
int count=0;  
RefreshRates();





 for(int n = 0;n<OrdersTotal();n++)
  {
   OrderSelect(n,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==magic){count++;}
     }

   if(count<1 && Hour()>timestart-1 || Hour()<timefin-1)
   {
    ticket1 = OrderSend(symb1,OP_SELL,0.1,MarketInfo(symb1,MODE_BID),3,0,0,0,magic,0,Red);
     ticket2 = OrderSend(symb2,OP_SELL,0.1,MarketInfo(symb2,MODE_BID),3,0,0,0,magic,0,Red);
      Comment(ticket1,ticket2);
       }
       
if(OrdersTotal()>0 && Hour()>=timefin)
  {
   for (int i=0;i<OrdersTotal();i++)
    {
     OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==magic)
       {del(OrderTicket());}
        } 
         }
if(OrdersTotal()>0)   
  {
   OrderSelect(ticket1, SELECT_BY_TICKET, MODE_TRADES);
    int profit1 = OrderProfit();
     OrderSelect(ticket2, SELECT_BY_TICKET, MODE_TRADES);
     int profit2 = OrderProfit();  
      Comment(ticket1+"  "+ticket2+"  "+profit1+"  "+profit2+"  "+(profit1+profit2)+"="+profit);
       if((profit1+profit2)-profit>0)
        {
         Print("profit",profit1+profit2,"  ",OrdersTotal());
          del(ticket1);
           del(ticket2);
            }           

   }      
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
int del(int ticket)
   {
    
    int err;
    for (int i=0;i<5;i++)
        {
        GetLastError();// 
        OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
        string symbol = OrderSymbol();
        
        if(OrderType()==OP_BUY)
         {
          RefreshRates();
           double prise = MarketInfo(symbol,MODE_BID);
            OrderClose(ticket,OrderLots(),prise,3,Green);
             err = GetLastError();
             }
        if(OrderType()==OP_SELL)
         {
          RefreshRates();
           prise = MarketInfo(symbol,MODE_ASK);
            OrderClose(ticket,OrderLots(),prise,3,Green);
             err = GetLastError();
             }
        
        if (err == 0){PlaySound("expert.wav");break;} if (err != 0) {PlaySound("timeout.wav");Print(err);} 
        while (!IsTradeAllowed()){ Sleep(5000);}//      5  
        } 
    return(err);     
    } 